//---------------------------------------------------------------------------
#ifndef SybSQLH
#define SybSQLH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>        
#include <DSGNINTF.HPP> 
#include <ExtCtrls.hpp>
#include <Buttons.hpp>              
#include "SybaseCommon.h"

//---------------------------------------------------------------------------
class TSQLEditit : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TMemo *SQLMemo;
        TSpeedButton *SaveButton;
        TSpeedButton *ClearButton;
        TSpeedButton *ExitButton;
        void __fastcall ClearButtonClick(TObject *Sender);
        void __fastcall SaveButtonClick(TObject *Sender);
        void __fastcall ExitButtonClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TSQLEditit();
};
//---------------------------------------------------------------------------
class PACKAGE TSybSQL : public TComponent
{
private:
  TString               *FDatabaseObject;
  bool                  FExecute;
  bool                  FCancelMessages;
  bool                  FGrid;
  TList                 *ColObjects; 
  TList                 *ColData;  
  TList                 *ColNums;
  int                   ColFound;
  void __fastcall       SetExecute(bool Value);
  void __fastcall       TSybSQL::DelColDetails();
  void _fastcall        SetCancelMessages(bool Value);
  void _fastcall        dbLocate( int column );
  void _fastcall        DoRows(int row);
  void _fastcall        ClearGrids();
  // events
  TNotifyEvent          FOnBeforeQuery;
  TNotifyEvent          FOnAfterQuery;  
  TNotifyEvent          FOnDbNoProcess;
  TNotifyEvent          FOnMissingDBObject;
  TNotifyEvent          FOnLoadSQLFail;
  TNotifyEvent          FOnExecuteFail;

protected:
public:
        __fastcall      TSybSQL(TComponent* Owner);
        __fastcall      ~TSybSQL();
// functions
    void __fastcall Execute();
// Variables
    DBPROCESS           *dbproc;
    DBINT               _dbretstatus;
    AnsiString          DatabaseObject;
    TStringList         *SQL;
    int                 column_count;
                                    
__published:
  __property TString *_DatabaseObject = {read=FDatabaseObject, write=FDatabaseObject};
  __property TStringList *_SQL = {read=SQL, write=SQL};            
// __property int _ColumnCount = {read=column_count, write =column_count};
  __property bool _Execute = {read=FExecute, write=SetExecute}; 
  __property bool CancelMessages  = { read =  FCancelMessages, write =  SetCancelMessages, default = false}; 
// events
    __property TNotifyEvent OnBeforeQuery = {read=FOnBeforeQuery, write=FOnBeforeQuery};
    __property TNotifyEvent OnAfterQuery = {read=FOnAfterQuery, write=FOnAfterQuery};   
    __property TNotifyEvent OnDbNoProcess = {read=FOnDbNoProcess, write=FOnDbNoProcess};
    __property TNotifyEvent OnMissingDBObject = {read=FOnMissingDBObject, write=FOnMissingDBObject};
    __property TNotifyEvent OnLoadSQLFail = {read=FOnLoadSQLFail, write=FOnLoadSQLFail};
    __property TNotifyEvent OnExecuteFail = {read=FOnExecuteFail, write=FOnExecuteFail};

};
//---------------------------------------------------------------------------

class  TSQLProperty : public TPropertyEditor
{
  public:
  //  __fastcall ~TGridProperty();  // destructor
    virtual System::AnsiString __fastcall GetValue(); // override;
    virtual void __fastcall GetValues(Classes::TGetStrProc Proc); // override;
    virtual void __fastcall SetValue(const System::AnsiString Value); // override;
    TPropertyAttributes virtual __fastcall GetAttributes(void);   // override
    virtual void __fastcall Initialize(void);     // override
    void __fastcall Edit(void); //override
    __property Designer;
    Classes::TPersistent* ThisComponent;
    TSybSQL *ptr;
};
//---------------------------------------------------------------------------
#endif
